﻿#include "pch.h"
#include "MyGPUClass.h"

using namespace appendix_runtime;
using namespace Platform;

MyGPUClass::MyGPUClass()
{
}

//	C++ AMP code 작성
#include <amp.h>
using namespace concurrency;

void MyGPUClass::Add(Platform::WriteOnlyArray<int>^ dst, const Platform::Array<int>^ src0, const Platform::Array<int>^ src1)
{
	int *d = dst->Data;
	int *s0 = src0->Data;
	int *s1 = src1->Data;

	array_view<const int, 1> a_s0(src0->Length, s0);
	array_view<const int, 1> a_s1(src1->Length, s1);
	array_view<int, 1> a_d(dst->Length, d);
	a_d.discard_data();

	parallel_for_each(a_d.extent, [=](index<1> idx) restrict(amp) {
		a_d[idx] = a_s0[idx] + a_s1[idx];
	});
	a_d.synchronize();
}
